;CodeVisionAVR C Compiler V1.0.1.4b Evaluation
;(C) Copyright 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
;http://infotech.ir.ro
;e-mail:dhptechn@ir.ro , hpinfotech@mail.com

;Chip type           : AT90S2313
;Clock frequency     : 10,000000 MHz
;Memory model        : Tiny
;Optimize for        : Size
;Internal SRAM size  : 128
;External SRAM size  : 0
;Data Stack size     : 32
;Promote char to int : No
;char is unsigned    : Yes
;Automatic register allocation : On
;Use AVR Studio Terminal I/O   : No

	.DEVICE AT90S2313
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU UBRR=0x9
	.EQU UCR=0xA
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __JMPZ
	BRNE __FALSE
	RJMP _@0
__FALSE:
	.ENDM

	.MACRO __JMPNZ
	BREQ __FALSE
	RJMP _@0
__FALSE:
	.ENDM

	.MACRO __EQB10
	TST  R30
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB10
	CPI  R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB10
	CLR  R0
	CP   R0,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB10
	CLR  R0
	CP   R0,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB10
	CPI  R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB10
	TST  R30
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW10
	SBIW R30,0
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW10
	SBIW R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW10
	RCALL __CPW01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW10
	RCALL __CPW01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW10
	SBIW R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW10
	SBIW R30,0
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD10
	RCALL __CPD10
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED10
	RCALL __CPD10
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD10
	RCALL __CPD01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED10
	RCALL __CPD01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD10
	RCALL __CPD10
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED10
	RCALL __CPD10
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB12J
	CP   R30,R26
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB12J
	CP   R30,R26
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12J
	CP   R30,R26
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12J
	CP   R26,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12J
	CP   R26,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12J
	CP   R30,R26
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12UJ
	CP   R30,R26
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12UJ
	CP   R26,R30
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12UJ
	CP   R26,R30
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12UJ
	CP   R30,R26
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW12J
	CP   R30,R26
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW12J
	CP   R30,R26
	CPC  R31,R27
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12J
	CP   R30,R26
	CPC  R31,R27
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12J
	CP   R26,R30
	CPC  R27,R31
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12J
	CP   R26,R30
	CPC  R27,R31
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12J
	CP   R30,R26
	CPC  R31,R27
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD12J
	RCALL __CPD12
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED12J
	RCALL __CPD12
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12J
	RCALL __CPD12
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12J
	RCALL __CPD21
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12J
	RCALL __CPD21
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12J
	RCALL __CPD12
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12UJ
	RCALL __CPD12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12UJ
	RCALL __CPD21
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12UJ
	RCALL __CPD21
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12UJ
	RCALL __CPD12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCS __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEF12J
	RCALL __CMPF12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTF12J
	RCALL __CMPF12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCC __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB1NJ
	CPI  R30,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB1NJ
	CPI  R30,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB2NJ
	CPI  R26,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB2NJ
	CPI  R26,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEBN1J
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTBN1J
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEBN1UJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTBN1UJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NJ
	CPI  R26,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NJ
	CPI  R26,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NUJ
	CPI  R26,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NUJ
	CPI  R26,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __BITSREG0
	BRBC @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __BITSREG1
	BRBS @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBR0
	TST  R@0
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR0
	TST  R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR0
	CLR  R0
	CP   R0,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR0
	CLR  R0
	CP   R0,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR0
	TST  R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBR0
	TST  R@0
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBRRJ
	CP   R@0,R@1
	BREQ __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __NEBRRJ
	CP   R@0,R@1
	BRNE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRJ
	CP   R@0,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRJ
	CP   R@1,R@0
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRJ
	CP   R@1,R@0
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRJ
	CP   R@0,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRUJ
	CP   R@0,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRUJ
	CP   R@1,R@0
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRUJ
	CP   R@1,R@0
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRUJ
	CP   R@0,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQW1NJ
	LDI  R27,HIGH(@1)
	CPI  R30,LOW(@1)
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __NEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEB1RJ
	CP   R30,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RJ
	CP   R@0,R30
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RJ
	CP   R@0,R30
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RJ
	CP   R30,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEB1RUJ
	CP   R30,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RUJ
	CP   R@0,R30
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RUJ
	CP   R@0,R30
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RUJ
	CP   R30,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2J
	CP   R@0,R26
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2J
	CP   R26,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2J
	CP   R26,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2J
	CP   R@0,R26
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2UJ
	CP   R@0,R26
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2UJ
	CP   R26,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2UJ
	CP   R26,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2UJ
	CP   R@0,R26
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQBRNJ
	CPI  R@0,LOW(@2)
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBRNJ
	CPI  R@0,LOW(@2)
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __TESTSREG
	LDI  R30,1
	BRBS @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __NTESTSREG
	LDI  R30,1
	BRBC @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __EQB1NJS
	CPI  R30,LOW(@1)
	BRNE _@0
	.ENDM

	.MACRO __EQB2NJS
	CPI  R26,LOW(@1)
	BRNE _@0
	.ENDM

	.MACRO __NEB1NJS
	CPI  R30,LOW(@1)
	BREQ _@0
	.ENDM

	.MACRO __NEB2NJS
	CPI  R26,LOW(@1)
	BREQ _@0
	.ENDM

	.MACRO __LEBN1JS
	CPI  R30,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __LEBN1UJS
	CPI  R30,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __GTBN1JS
	CPI  R30,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __GTBN1UJS
	CPI  R30,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __GEB1NJS
	CPI  R30,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __GEB2NJS
	CPI  R26,LOW(@1)
	BRLT _@0
	.ENDM

	.MACRO __GEB1NUJS
	CPI  R30,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __GEB2NUJS
	CPI  R26,LOW(@1)
	BRLO _@0
	.ENDM

	.MACRO __LTB1NJS
	CPI  R30,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __LTB2NJS
	CPI  R26,LOW(@1)
	BRGE _@0
	.ENDM

	.MACRO __LTB1NUJS
	CPI  R30,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __LTB2NUJS
	CPI  R26,LOW(@1)
	BRSH _@0
	.ENDM

	.MACRO __EQBR0S
	TST  R@0
	BRNE _@1
	.ENDM

	.MACRO __GEBR0S
	TST  R@0
	BRLT _@1
	.ENDM

	.MACRO __GTBR0S
	CLR  R0
	CP   R0,R@0
	BRGE _@1
	.ENDM

	.MACRO __LEBR0S
	CLR  R0
	CP   R0,R@0
	BRLT _@1
	.ENDM

	.MACRO __LTBR0S
	TST  R@0
	BRGE _@1
	.ENDM

	.MACRO __NEBR0S
	TST  R@0
	BREQ _@1
	.ENDM

	.MACRO __EQBRRJS
	CP   R@0,R@1
	BRNE _@2
	.ENDM

	.MACRO __NEBRRJS
	CP   R@0,R@1
	BREQ _@2
	.ENDM

	.MACRO __LEBRRJS
	CP   R@0,R@1
	BRLT _@2
	.ENDM

	.MACRO __GEBRRJS
	CP   R@1,R@0
	BRLT _@2
	.ENDM

	.MACRO __LTBRRJS
	CP   R@1,R@0
	BRGE _@2
	.ENDM

	.MACRO __GTBRRJS
	CP   R@0,R@1
	BRGE _@2
	.ENDM

	.MACRO __LEBRRUJS
	CP   R@0,R@1
	BRLO _@2
	.ENDM

	.MACRO __GEBRRUJS
	CP   R@1,R@0
	BRLO _@2
	.ENDM

	.MACRO __LTBRRUJS
	CP   R@1,R@0
	BRSH _@2
	.ENDM

	.MACRO __GTBRRUJS
	CP   R@0,R@1
	BRSH _@2
	.ENDM

	.MACRO __EQW1NJS
	LDI  R27,HIGH(@1)
	CPI  R30,LOW(@1)
	CPC  R31,R27
	BRNE _@0
	.ENDM

	.MACRO __EQWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE _@4
	.ENDM

	.MACRO __NEWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ _@4
	.ENDM

	.MACRO __LEWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT _@4
	.ENDM

	.MACRO __GEWRRJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT _@4
	.ENDM

	.MACRO __LTWRRJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE _@4
	.ENDM

	.MACRO __GTWRRJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE _@4
	.ENDM

	.MACRO __LEWRRUJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO _@4
	.ENDM

	.MACRO __GEWRRUJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO _@4
	.ENDM

	.MACRO __LTWRRUJS
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH _@4
	.ENDM

	.MACRO __GTWRRUJS
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH _@4
	.ENDM

	.MACRO __EQBRNJS
	CPI  R@0,LOW(@2)
	BRNE _@1
	.ENDM

	.MACRO __NEBRNJS
	CPI  R@0,LOW(@2)
	BREQ _@1
	.ENDM

	.MACRO __GEBRNJS
	CPI  R@0,LOW(@2)
	BRLT _@1
	.ENDM

	.MACRO __LTBRNJS
	CPI  R@0,LOW(@2)
	BRGE _@1
	.ENDM

	.MACRO __GEBRNUJS
	CPI  R@0,LOW(@2)
	BRLO _@1
	.ENDM

	.MACRO __LTBRNUJS
	CPI  R@0,LOW(@2)
	BRSH _@1
	.ENDM

	.MACRO __LEB1RJS
	CP   R30,R@0
	BRLT _@1
	.ENDM

	.MACRO __GEB1RJS
	CP   R@0,R30
	BRLT _@1
	.ENDM

	.MACRO __LTB1RJS
	CP   R@0,R30
	BRGE _@1
	.ENDM

	.MACRO __GTB1RJS
	CP   R30,R@0
	BRGE _@1
	.ENDM

	.MACRO __LEB1RUJS
	CP   R30,R@0
	BRLO _@1
	.ENDM

	.MACRO __GEB1RUJS
	CP   R@0,R30
	BRLO _@1
	.ENDM

	.MACRO __LTB1RUJS
	CP   R@0,R30
	BRSH _@1
	.ENDM

	.MACRO __GTB1RUJS
	CP   R30,R@0
	BRSH _@1
	.ENDM

	.MACRO __LEBR2JS
	CP   R@0,R26
	BRLT _@1
	.ENDM

	.MACRO __GEBR2JS
	CP   R26,R@0
	BRLT _@1
	.ENDM

	.MACRO __LTBR2JS
	CP   R26,R@0
	BRGE _@1
	.ENDM

	.MACRO __GTBR2JS
	CP   R@0,R26
	BRGE _@1
	.ENDM

	.MACRO __LEBR2UJS
	CP   R@0,R26
	BRLO _@1
	.ENDM

	.MACRO __GEBR2UJS
	CP   R26,R@0
	BRLO _@1
	.ENDM

	.MACRO __LTBR2UJS
	CP   R26,R@0
	BRSH _@1
	.ENDM

	.MACRO __GTBR2UJS
	CP   R@0,R26
	BRSH _@1
	.ENDM

	.MACRO __LEW1RJS
	CP   R30,R@0
	CPC  R31,R@1
	BRLT _@2
	.ENDM

	.MACRO __GEW1RJS
	CP   R@0,R30
	CPC  R@1,R31
	BRLT _@2
	.ENDM

	.MACRO __LTW1RJS
	CP   R@0,R30
	CPC  R@1,R31
	BRGE _@2
	.ENDM

	.MACRO __GTW1RJS
	CP   R30,R@0
	CPC  R31,R@1
	BRGE _@2
	.ENDM

	.MACRO __LEW1RUJS
	CP   R30,R@0
	CPC  R31,R@1
	BRLO _@2
	.ENDM

	.MACRO __GEW1RUJS
	CP   R@0,R30
	CPC  R@1,R31
	BRLO _@2
	.ENDM

	.MACRO __LTW1RUJS
	CP   R@0,R30
	CPC  R@1,R31
	BRSH _@2
	.ENDM

	.MACRO __GTW1RUJS
	CP   R30,R@0
	CPC  R31,R@1
	BRSH _@2
	.ENDM

	.MACRO __LEWR2JS
	CP   R@0,R26
	CPC  R@1,R27
	BRLT _@2
	.ENDM

	.MACRO __GEWR2JS
	CP   R26,R@0
	CPC  R27,R@1
	BRLT _@2
	.ENDM

	.MACRO __LTWR2JS
	CP   R26,R@0
	CPC  R27,R@1
	BRGE _@2
	.ENDM

	.MACRO __GTWR2JS
	CP   R@0,R26
	CPC  R@1,R27
	BRGE _@2
	.ENDM

	.MACRO __LEWR2UJS
	CP   R@0,R26
	CPC  R@1,R27
	BRLO _@2
	.ENDM

	.MACRO __GEWR2UJS
	CP   R26,R@0
	CPC  R27,R@1
	BRLO _@2
	.ENDM

	.MACRO __LTWR2UJS
	CP   R26,R@0
	CPC  R27,R@1
	BRSH _@2
	.ENDM

	.MACRO __GTWR2UJS
	CP   R@0,R26
	CPC  R@1,R27
	BRSH _@2
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.CSEG
	.ORG 0x0B

	.INCLUDE "nussknacker.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31
	OUT  MCUCR,R30

;CLEAR R2-R15
	LDI  R24,14
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	MOV  R1,R0
	ADIW R30,1
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	MOV  R26,R0
	ADIW R30,1
	LPM
	MOV  R27,R0
	ADIW R30,1
	LPM
	MOV  R24,R0
	ADIW R30,1
	LPM
	MOV  R25,R0
	ADIW R30,1
__GLOBAL_INI_LOOP:
	LPM
	ST   X+,R0
	ADIW R30,1
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x7F)

	RJMP _main

	.ESEG
	.ORG 1

	.DSEG
	.ORG 0x80
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.0.1.4b Evaluation
;       4 Automatic Program Generator
;       5  Copyright 1998-2001
;       6 Pavel Haiduc, HP InfoTech S.R.L.
;       7 http://infotech.ir.ro
;       8 e-mail:dhptechn@ir.ro , hpinfotech@mail.com
;       9 
;      10 Project : 
;      11 Version : 
;      12 Date    : 21.12.2001
;      13 Author  : Unknown
;      14 Company : 
;      15 Comments: 
;      16 
;      17 
;      18 Chip type           : AT90S2313
;      19 Clock frequency     : 10,000000 MHz
;      20 Memory model        : Tiny
;      21 Internal SRAM size  : 128
;      22 External SRAM size  : 0
;      23 Data Stack size     : 32
;      24 *********************************************/
;      25 
;      26 #include <90s2313.h>
;      27 // CodeVisionAVR C Compiler
;      28 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      29 
;      30 // I/O registers definitions for the AT90S2313
;      31 
;      32 #ifndef _90S2313_INCLUDED_
;      33 #define _90S2313_INCLUDED_
;      34 
;      35 #pragma used+
;      36 sfrb ACSR=8;
;      37 sfrb UBRR=9;
;      38 sfrb UCR=0xa;
;      39 sfrb USR=0xb;
;      40 sfrb UDR=0xc;
;      41 sfrb PIND=0x10;
;      42 sfrb DDRD=0x11;
;      43 sfrb PORTD=0x12;
;      44 sfrb PINB=0x16;
;      45 sfrb DDRB=0x17;
;      46 sfrb PORTB=0x18;
;      47 sfrb EECR=0x1c;
;      48 sfrb EEDR=0x1d;
;      49 sfrb EEAR=0x1e;
;      50 sfrb WDTCR=0x21;
;      51 sfrb ICR1L=0x24;
;      52 sfrb ICR1H=0x25;
;      53 sfrw ICR1=0x24;   // 16 bit access
;      54 sfrb OCR1L=0x2a;
;      55 sfrb OCR1H=0x2b;
;      56 sfrw OCR1=0x2a;   // 16 bit access
;      57 sfrb TCNT1L=0x2c;
;      58 sfrb TCNT1H=0x2d;
;      59 sfrw TCNT1=0x2c;  // 16 bit access
;      60 sfrb TCCR1B=0x2e;
;      61 sfrb TCCR1A=0x2f;
;      62 sfrb TCNT0=0x32;
;      63 sfrb TCCR0=0x33;
;      64 sfrb MCUSR=0x34;
;      65 sfrb MCUCR=0x35;
;      66 sfrb TIFR=0x38;
;      67 sfrb TIMSK=0x39;
;      68 sfrb GIFR=0x3a;
;      69 sfrb GIMSK=0x3b;
;      70 sfrb SPL=0x3d;
;      71 sfrb SREG=0x3f;
;      72 #pragma used-
;      73 
;      74 #define OCR1AL OCR1L
;      75 #define OCR1AH OCR1H
;      76 
;      77 // Interrupt vectors definitions
;      78 
;      79 #define EXT_INT0 2
;      80 #define EXT_INT1 3
;      81 #define TIM1_CAPT 4
;      82 #define TIM1_COMP 5
;      83 #define TIM1_OVF 6
;      84 #define TIM0_OVF 7
;      85 #define UART_RXC 8
;      86 #define UART_DRE 9
;      87 #define UART_TXC 10
;      88 #define ANA_COMP 11
;      89 
;      90 #endif
;      91 
;      92 
;      93 #define heber 1
;      94 #define freigabe 2
;      95 #define sw_heber 1
;      96 #define sw_freigabe1 2
;      97 #define sw_freigabe2 4
;      98 #define sw_taster 8
;      99 
;     100 // Declare your global variables here
;     101 
;     102 void sleep (void)
;     103 {

	.CSEG
_sleep:
;     104  int z1,z2,z3;
;     105  for (z1=1;z1<20;z1++)
	RCALL __SAVELOCR6
;	z1 -> R16,R17
;	z2 -> R18,R19
;	z3 -> R20,R21
	__GETWRN 16,17,1
_0x2:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	__LTW1RJS 16,17,4
;     106   for (z2=1;z2<10000;z2++)
	__GETWRN 18,19,1
_0x5:
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	__LTW1RJS 18,19,7
;     107    z3=z2;
	__MOVEWRR 20,21,18,19
_0x6:
	__ADDWRN 18,19,1
	RJMP _0x5
_0x7:
_0x3:
	__ADDWRN 16,17,1
	RJMP _0x2
_0x4:
;     108 }
	RCALL __LOADLOCR6
	ADIW R28,6
	RET
;     109 
;     110 void main(void)
;     111 {
_main:
;     112 // Declare your local variables here
;     113 
;     114 // Input/Output Ports initialization
;     115 // Port B
;     116 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     117 PORTB=0x00;
	CLR  R30
	OUT  0x18,R30
;     118 
;     119 // Port D
;     120 DDRD=0x00;
	OUT  0x11,R30
;     121 PORTD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x12,R30
;     122 
;     123 // Timer/Counter 0 initialization
;     124 // Clock source: System Clock
;     125 // Clock value: Timer 0 Stopped
;     126 // Mode: Output Compare
;     127 // OC0 output: Disconnected
;     128 TCCR0=0x00;
	CLR  R30
	OUT  0x33,R30
;     129 TCNT0=0x00;
	OUT  0x32,R30
;     130 
;     131 // Timer/Counter 1 initialization
;     132 // Clock source: System Clock
;     133 // Clock value: Timer 1 Stopped
;     134 // Mode: Output Compare
;     135 // OC1 output: Discon.
;     136 // Noise Canceler: Off
;     137 // Input Capture on Falling Edge
;     138 TCCR1A=0x00;
	OUT  0x2F,R30
;     139 TCCR1B=0x00;
	OUT  0x2E,R30
;     140 TCNT1H=0x00;
	OUT  0x2D,R30
;     141 TCNT1L=0x00;
	OUT  0x2C,R30
;     142 OCR1H=0x00;
	OUT  0x2B,R30
;     143 OCR1L=0x00;
	OUT  0x2A,R30
;     144 
;     145 // External Interrupt(s) initialization
;     146 // INT0: Off
;     147 // INT1: Off
;     148 GIMSK=0x00;
	OUT  0x3B,R30
;     149 MCUCR=0x00;
	OUT  0x35,R30
;     150 
;     151 // Timer(s)/Counter(s) Interrupt(s) initialization
;     152 TIMSK=0x00;
	OUT  0x39,R30
;     153 
;     154 // Analog Comparator initialization
;     155 // Analog Comparator: Off
;     156 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     157 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     158 
;     159 while (1)
_0x9:
;     160       {
;     161       
;     162       // Freigabe in Fallposition fahren
;     163       PORTB|=freigabe;        
	SBI  0x18,1
;     164       sleep();
	RCALL _sleep
;     165       while (PIND & sw_freigabe2) 
_0xB:
	RCALL SUBOPT_0x0
	BREQ _0xC
;     166       {
;     167       }
	RJMP _0xB
_0xC:
;     168       PORTB&=0xff-freigabe;
	CBI  0x18,1
;     169       sleep();
	RCALL SUBOPT_0x1
;     170       sleep();
;     171       sleep();
	RCALL SUBOPT_0x1
;     172       sleep();
;     173       sleep();
	RCALL SUBOPT_0x1
;     174       sleep();
;     175       sleep();
	RCALL SUBOPT_0x1
;     176       sleep();
;     177       sleep();
	RCALL SUBOPT_0x1
;     178       sleep();
;     179       sleep();
	RCALL _sleep
;     180       
;     181       // Freigabe in Hebeposition fahren
;     182       PORTB|=freigabe;
	SBI  0x18,1
;     183       sleep();
	RCALL _sleep
;     184       
;     185       while (PIND & sw_freigabe1) 
_0xD:
	RCALL SUBOPT_0x2
	BREQ _0xE
;     186       {
;     187       }
	RJMP _0xD
_0xE:
;     188       PORTB&=0xff-freigabe;
	CBI  0x18,1
;     189       sleep;
	LDI  R30,LOW(_sleep)
	LDI  R31,HIGH(_sleep)
;     190       
;     191       // Hammer ist unten, Freigabe steht auf Heben -> Freigabe fr Betrieb
;     192       
;     193       while (1)
_0xF:
;     194       {
;     195       
;     196       // Warten auf Tastendruck
;     197       while (PIND & sw_taster)
_0x11:
	RCALL SUBOPT_0x3
	BREQ _0x12
;     198        {              
;     199        sleep();
	RCALL _sleep
;     200        }
	RJMP _0x11
_0x12:
;     201       sleep ();
	RCALL _sleep
;     202       // Warten auf Taste losgelassen
;     203       while (!(PIND & sw_taster))
_0x13:
	RCALL SUBOPT_0x3
	BRNE _0x14
;     204        {       
;     205        sleep();
	RCALL _sleep
;     206        }
	RJMP _0x13
_0x14:
;     207       sleep ();
	RCALL _sleep
;     208              
;     209       // Taste wurde gedrckt, also hochfahren
;     210       PORTB|=heber;               
	SBI  0x18,0
;     211       sleep();
	RCALL _sleep
;     212       
;     213       while (PIND & sw_heber)
_0x15:
	IN   R30,0x10
	ANDI R30,LOW(0x1)
	BREQ _0x16
;     214       {
;     215       }
	RJMP _0x15
_0x16:
;     216 
;     217       PORTB&=0xff-heber;                
	CBI  0x18,0
;     218       sleep (); 
	RCALL _sleep
;     219       
;     220       // Hammer ist oben, warten auf Nuss
;     221       // Warten auf Tastendruck
;     222       while (PIND & sw_taster)
_0x17:
	RCALL SUBOPT_0x3
	BREQ _0x18
;     223        {
;     224         sleep();
	RCALL _sleep
;     225        }
	RJMP _0x17
_0x18:
;     226       sleep ();
	RCALL _sleep
;     227       // Warten auf Taste losgelassen
;     228       while (!(PIND & sw_taster))
_0x19:
	RCALL SUBOPT_0x3
	BRNE _0x1A
;     229        {        
;     230         sleep();
	RCALL _sleep
;     231        }
	RJMP _0x19
_0x1A:
;     232       sleep ();
	RCALL _sleep
;     233              
;     234             
;     235       // Hammer fallen lassen
;     236       // Freigabe in Fallposition fahren
;     237       PORTB|=freigabe;        
	SBI  0x18,1
;     238       sleep();
	RCALL _sleep
;     239       while (PIND & sw_freigabe2) 
_0x1B:
	RCALL SUBOPT_0x0
	BREQ _0x1C
;     240       {
;     241       };
	RJMP _0x1B
_0x1C:
;     242        
;     243       PORTB&=0xff-freigabe;
	CBI  0x18,1
;     244       sleep ();
	RCALL SUBOPT_0x1
;     245       sleep ();
;     246       sleep ();
	RCALL SUBOPT_0x1
;     247       sleep ();
;     248       sleep ();
	RCALL SUBOPT_0x1
;     249       sleep ();
;     250       sleep ();
	RCALL SUBOPT_0x1
;     251       sleep ();
;     252       sleep ();
	RCALL _sleep
;     253       
;     254       // Freigabe in Hebeposition fahren
;     255       while (PIND & sw_freigabe1) 
_0x1D:
	RCALL SUBOPT_0x2
	BREQ _0x1E
;     256        PORTB|=freigabe;
	SBI  0x18,1
	RJMP _0x1D
_0x1E:
;     257       
;     258       PORTB&=0xff-freigabe;
	CBI  0x18,1
;     259       sleep;      
	LDI  R30,LOW(_sleep)
	LDI  R31,HIGH(_sleep)
;     260        
;     261                
;     262       };
	RJMP _0xF
_0x10:
;     263 
;     264       };
	RJMP _0x9
_0xA:
;     265 }
	RET
;     266             

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	IN   R30,0x10
	ANDI R30,LOW(0x4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x1:
	RCALL _sleep
	RJMP _sleep

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	IN   R30,0x10
	ANDI R30,LOW(0x2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x3:
	IN   R30,0x10
	ANDI R30,LOW(0x8)
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

	.ORG 0

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
